<?php

namespace Database;
use DateTime;
use Model\Activity;
use Shared\Log;

class ActivityMapper {
    public function activitySqlToEntity(array $data):array
    {
        $activityEntities = [];

        foreach ($data as $activityData) {
            $activity = new ActivityEntity();

            if (isset($activityData['idactivite'])) {
                $activity->setIdActivity($activityData['idactivite']);
            }

            if (isset($activityData['type'])) {
                $activity->setType($activityData['type']);
            }

            if (isset($activityData['date'])) {
                $activity->setDate($activityData['date']);
            }

            if (isset($activityData['heurededebut'])) {
                $activity->setHeureDebut($activityData['heurededebut']);
            }

            if (isset($activityData['heuredefin'])) {
                $activity->setHeureFin($activityData['heuredefin']);
            }

            if (isset($activityData['effortressent'])) {
                $activity->setEffortRessenti($activityData['effortressent']);
            }

            if (isset($activityData['variabilite'])) {
                $activity->setVariabilite($activityData['variabilite']);
            }

            if (isset($activityData['variance'])) {
                $activity->setVariance($activityData['variance']);
            }

            if (isset($activityData['ecarttype'])) {
                $activity->setEcartType($activityData['ecarttype']);
            }

            if (isset($activityData['moyenne'])) {
                $activity->setMoyenne($activityData['moyenne']);
            }

            if (isset($activityData['maximum'])) {
                $activity->setMaximum($activityData['maximum']);
            }

            if (isset($activityData['minimum'])) {
                $activity->setMinimum($activityData['minimum']);
            }

            if (isset($activityData['temperaturemoyenne'])) {
                $activity->setTemperatureMoyenne($activityData['temperaturemoyenne']);
            }

            $activityEntities[] = $activity;
        }
        return $activityEntities;
    }

    /**
     * @throws \Exception
     */
    public function ActivityEntityToModel(ActivityEntity $activiteEntity):Activity {
        $date = new DateTime($activiteEntity->getDate());
        $heureDebut = new \DateTime($activiteEntity->getHeureDebut());
        $heureFin = new \DateTime($activiteEntity->getHeureFin());
        $effortRessenti = intval($activiteEntity->getEffortRessenti());
        $variability = floatval($activiteEntity->getVariability());
        $variance = floatval($activiteEntity->getVariance());
        $ecartType = floatval($activiteEntity->getEcartType());

        $act = new Activity(
            $activiteEntity->getIdActivity(),
            $activiteEntity->getType(),
            $date,
            $heureDebut,
            $heureFin,
            $effortRessenti,
            $variability,
            $variance,
            $ecartType,
            $activiteEntity->getMoyenne(),
            $activiteEntity->getMaximum(),
            $activiteEntity->getMinimum(),
            $activiteEntity->getTemperatureMoyenne(),
            'false'
        );

        return $act;
    }
    //public function ActivityToEntity(Activity model): ActivityEntity;

    public function activityToEntity(Activity $act):ActivityEntity{

        $act = new ActivityEntity();
        $act->setIdActivity($act->getIdActivity()());
        $act->setType($act->getType());
        $act->setDate($act->getDate());
        $act->setHeureDebut($act->getHeureDebut());
        $act->setHeureFin($act->getHeureFin());
        $act->setEffortRessenti($act->getEffortRessenti());
        $act->setVariabilite($act->getVariability());
        $act->setVariance($act->getVariance());
        $act->setEcartType($act->getEcartType());
        $act->setMoyenne($act->getMoyenne());
        $act->setMaximum($act->getMaximum());
        $act->setMinimum($act->getMinimum());
        $act->setTemperatureMoyenne($act->getTemperatureMoyenne());

        return $act;
    }
}

?>
